package intredblacktree;

public class IntRedBlackTreeB3 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB3());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB3();
  }

  @Override
  protected Node treeDelete(Node z) {
    if (z == null)
      return null;

    Node x, y;
    if (z.left == null || z.right == null)
      y = z;
    else
      y = getIOS(z);

    if (y.left != null)
      x = y.left;
    else
      x = y.right;

    if (x != null)
      x.parent = y.parent;

    if (y.parent == null)
      root = x;
    // else if (y == y.parent.left) // BUG (line removed)
    // y.parent.left = x; // BUG (line removed)
    else
      y.parent.right = x;

    if (y != z) {
      z.key = y.key;
      z.value = y.value;
    }

    if (getColor(y) == BLACK)
      if (x == null)
        // hack
        treeDeleteFix(y);
      else
        treeDeleteFix(x);

    return y;
  }

}
