package intredblacktree;

public class IntRedBlackTreeB5 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB5());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB5();
  }

  @Override
  protected void treeInsertFix(Node z) {
    while (getColor(z.parent) == RED) {
      if (parent(z) == left(parent(parent(z)))) {
        Node y = right(parent(parent(z)));
        if (getColor(y) == RED) {
          setColor(parent(z), BLACK);
          setColor(y, BLACK);
          setColor(parent(parent(z)), RED);
          z = parent(parent(z));
        } else {
          if (z == right(parent(z))) {
            z = parent(z);
            leftRotate(z);
          }
          setColor(parent(z), BLACK);
          setColor(parent(parent(z)), RED);
          if (parent(parent(z)) != null)
            rightRotate(parent(parent(z)));
        }
      } else {
        // Node y = left(parent(parent(z))); // BUG (line changed)
        Node y = left(parent(parent(parent(z)))); // BUG
        if (getColor(y) == RED) {
          setColor(parent(z), BLACK);
          setColor(y, BLACK);
          setColor(parent(parent(z)), RED);
          z = parent(parent(z));
        } else {
          if (z == left(parent(z))) {
            z = parent(z);
            rightRotate(z);
          }
          setColor(parent(z), BLACK);
          setColor(parent(parent(z)), RED);
          if (parent(parent(z)) != null)
            leftRotate(parent(parent(z)));
        }
      }
    }
    root.color = BLACK;
  }

}
