package intredblacktree;

public class IntRedBlackTreeB7 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB7());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB7();
  }

  @Override
  protected void treeInsert(Node z) {
    Node y = null;
    Node x = root;
    while (x != null) {
      y = x;
      if (((Integer) z.key).compareTo(x.key) < 0)
        x = x.left;
      else if (((Integer) z.key).compareTo(x.key) == 0) {
        x.value = z.value;
        size--;
        return;
      } else
        x = x.right;
    }
    z.parent = y;
    if (y == null)
      root = z;
    else if (((Integer) z.key).compareTo(y.key) < 0)
      y.left = z;
    else
      y.right = z;
    z.left = null;
    z.right = null;
    z.color = RED;

    if (((Integer) z.key).compareTo(y.key) > 0) // BUG (line inserted)
      treeInsertFix(y.left); // BUG (line inserted)
    else
      treeInsertFix(z);
  }

}
