package intredblacktree;

public class IntRedBlackTreeB1 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB1());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB1();
  }

  @Override
  protected void rightRotate(Node x) {
    Node y = x.left;
    x.left = y.right;
    if (y.right != null)
      y.right.parent = x;
    // y.parent = x.parent; // BUG (line removed)
    if (x.parent == null)
      root = y;
    else if (x == x.parent.right)
      x.parent.right = y;
    else
      x.parent.left = y;
    y.right = x;
    x.parent = y;
  }

}
