package intredblacktree;

public class IntRedBlackTreeB2 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB2());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB2();
  }

  @Override
  protected void rightRotate(Node x) {
    Node y = x.left;
    x.left = y.right;
    if (y.right != null)
      y.right.parent = x;
    y.parent = x.parent;
    if (x.parent == null)
      root = y;
    else if (x == x.parent.right)
      x.parent.right = y;
    // else // BUG (line removed)
    // x.parent.left = y; // BUG (line removed)
    y.right = x;
    x.parent = y;
  }

}
