package intredblacktree;

public class IntRedBlackTreeB4 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB4());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB4();
  }

  @Override
  protected Node treeDelete(Node z) {
    if (z == null)
      return null;

    Node x, y;
    if (z.left == null || z.right == null)
      y = z;
    else
      y = getIOS(z);

    if (y.left != null)
      x = y.left;
    else
      x = y.right;

    if (x != null)
      x.parent = y.parent;

    if (y.parent == null)
      root = x;
    else if (y == y.parent.left)
      y.parent.left = x;
    else
      y.parent.right = x;

    if (y != z) {
      z.key = y.key;
      z.value = y.value;
    }

    if (getColor(y) == BLACK)
      if (x == null)
        ; // BUG
      // treeDeleteFix(y); // BUG (line removed)
      else
        ; // BUG
    // treeDeleteFix(x); // BUG (line removed)
    return y;
  }

}
