package intredblacktree;

public class IntRedBlackTreeB8 extends IntRedBlackTreeUDITA {

  public static void main(String[] args) {
    superMain(args, new IntRedBlackTreeB8());
  }

  @Override
  public IntRedBlackTreeUDITA newIntRedBlackTree() {
    return new IntRedBlackTreeB8();
  }

  @Override
  protected void rightRotate(Node x) {
    Node y = x.left;
    x.left = y.right;
    if (y.right != null)
      y.right.parent = x;
    y.parent = x.parent;
    if (x.parent == null)
      root = y;
    else if (x == x.parent.right)
      // x.parent.right = y; // BUG (line changed)
      x.parent.left = y; // BUG
    else
      // x.parent.left = y; // BUG (line changed)
      x.parent.right = y; // BUG
    y.right = x;
    x.parent = y;
  }

}
